/* GDFuser.C
      controls user actions
*/

   /* user row and column selection of displayed lists */
int Urow[3]    = {0,0,0};
int Ucolumn[3] = {0,0,0};

/* prototypes */

void UserGDF(void);
     /* controls the actions initated by the user */

/* implimentation */

void UserGDF(void)
     /* controls the actions initated by the user */
{ int  I;
  int  list = DEFNLIST;         /* active list from defn/rt/acronym (DRA) */
  int  oldlist;                 /* holds a copy of list */
  int  repeat = 1;              /* false when user wishes to stop */
  char startEdit;               /* true if user has started editing field */
  int  exitkey = 0;             /* return key+double_key from editing */
  unsigned char option = ' ';   /* current user action */
  unsigned char opt;            /* double_key value */

     /* initiallize the Menu and Lists */
  SetMenus();
  MenuWrite();
  NullLists();
  NullDRA();
     /* display program identification */
  PrintCharWindow('R',3,WHITE,BLACK,"AUSTRALIAN SOCIETY of EXPLORATION GEOPHYSICISTS");
  PrintCharWindow('R',4,WHITE,BLACK,"GENERAL DATA FORMAT");
  PrintCharWindow('R',5,WHITE,BLACK,GDFVERSION);

     /* initiallize the libraries and optionally load one */
  for (I = 0; I < LIBLIMIT ; I++) sourceName[I][0] = '\0';
  GetLib('i');
     /* clear program ident off the screen */
  for (I = 3; I < 6; I++) PrintCharWindow('l',I,WHITE,BLACK,"");
     /* initiallize the DRA lists; fill from library */
  AcroListInit(17);
  RTListInit(13);
  DefnListInit(9);
     /* display lists */
  DefnRelist(-2,Ucolumn[list]);

     /* main control loop for user actions */
  while (repeat) {
       /* process user option */
    startEdit = false;
    if (exitkey == 0) option = getch(); /* wait for user */
    else { option = exitkey % 256; exitkey /= 256; } /* split double key */
    switch (option) {
      case  0 : if (exitkey == 0) option = getch();
                else { option = exitkey; exitkey = 0; }  /* get double key */
               /* determine if an Alt_key (menu selection) was pressed */
            if ( ((option>=16) && (option<=25))
              || ((option>=30) && (option<=38))
              || ((option>=44) && (option<=50))) opt = ALT;
            else opt = option;
               /* execute user selection */
            oldlist = list;
            switch (opt) {
              case CTRLLARROW : oldlist = list + 1;
              case CTRLRARROW : Ucolumn[list] = MoveDRAlistColumn(list, 0); /* move to first col */
                             switch (list) {  /* ensure empty entries stored */
                   /* defn */  case 0 : Urow[1] = 0;     /* make RT_row=0 */
                   /* rt   */  case 1 : if (ListFixFill(list,Urow[list]))
                                          UpdateDRA(list,Urow[list],0);
                                        break;
                   /* acro */  case 2 : Urow[list] = 0;   /* make A_row=0 */
                             }
                             list = (++oldlist % 3);
                             ListRedisplay(list,Urow[list],Ucolumn[list]); break;
              case SHIFTTAB: Ucolumn[list]--; break;
              case LARROW  : ;
              case RARROW  : startEdit = true; option += 128; break;
              case UPARROW : Urow[list]--; break;
              case DNARROW : Urow[list]++; break;
              case PAGEUP  : Urow[list] -= Lt[list].page;
                             if (Urow[list] >= 0) break;
              case HOME    : Urow[list]  = 0; break;
              case PAGEDN  : Urow[list] += Lt[list].page;
                             if (Urow[list] < Lt[list].used) break;
              case END     : Urow[list]  = Lt[list].used-1; break;
              case INS : DRAins(list,Urow[list]);
                         ListRestart(list, Ucolumn[list]); break;
              case DEL : if (alertYesNo("Do you actually want to","DELETE the WHOLE LINE ?")) {
                           DRAdel(list,Urow[list]);
                           ListRestart(list, Ucolumn[list]);
                         } break;
              case ALT : exitkey =  ProcessMenu(list,option);
                         repeat = exitkey;
                         if (exitkey == 1) exitkey = 0;
                         ListRestart(list, Ucolumn[list]);
                         break;
              default  : putchar(BELL);   /* unknown request */
            }
            if (Urow[list] >= Lt[list].limit) {
              Urow[list] = Lt[list].limit - 1;
              alert('A',"Maximum number of entries","has already been used");
            }
            if (Urow[list] != Lt[list].row+Lt[list].start) /* row changed */
              Urow[list] = MoveDRAlistRow(list, Urow[list]);
            break;
      case TAB   : Ucolumn[list]++; break;
      case CUT   : exitkey = 256*DEL;
      case COPY  : CopyDRA(list); break;
      case PASTE : PasteDRA(list); break;
      case ENTER : break;
      case ESC   : repeat = -1; break;
         /* else assume user typing into a field */
      default    : if (option > 31) startEdit = true;
                   else putchar(BELL);   /* unknown control key */
    }
       /* edit field if user has started typing */
    if (startEdit) {
      exitkey = DoEdit(Lt[list].row,Ucolumn[list],option,list);
      if ((exitkey != ESC) && (Urow[list] == Lt[list].used) && (Lt[list].page > Lt[list].used))
        Lt[list].used++;
      UpdateDRA(list,Urow[list],Ucolumn[list]);
    }
       /* has column changed ? */
    if (Ucolumn[list] != Lt[list].column)
        Ucolumn[list] = MoveDRAlistColumn(list, Ucolumn[list]);
       /* fix up returns */
    if (repeat<1) {
      if (repeat == 0)
        repeat = 1 - alertYesNo("Do you really wish to quit from ASEG-GDF","Yes/No");
      else repeat = 1;
    }
  }
     /* make sure all file buffers are dumped */
  if (sourceStream != NULL) fclose(sourceStream); sourceStream = NULL;
  if (destStream != NULL)   fclose(destStream);   destStream = NULL;
  if (stream != NULL)       fclose(stream);       stream = NULL;
}

